---
title: WebGL2RenderingContext
slug: Web/API/WebGL2RenderingContext
tags:
  - API
  - Reference
  - WebGL
  - WebGL2
---
<div>{{APIRef("WebGL")}}</div>

<p>The <strong>WebGL2RenderingContext</strong> interface provides the OpenGL ES 3.0 rendering context for the drawing surface of an HTML {{HTMLElement("canvas")}} element.</p>

<p>To get an object of this interface, call {{domxref("HTMLCanvasElement.getContext()", "getContext()")}} on a <code>&lt;canvas&gt;</code> element, supplying "webgl2" as the argument:</p>

<pre class="brush: js">var canvas = document.getElementById('myCanvas');
var gl = canvas.getContext('webgl2');
</pre>

<div class="note">
<p>WebGL 2 is an extension to WebGL 1. The <code>WebGL2RenderingContext</code> interface implements all members of the {{domxref("WebGLRenderingContext")}} interface. Some methods of the WebGL 1 context can accept additional values when used in a WebGL 2 context. You will find this info noted on the WebGL 1 reference pages.</p>
</div>

<p>The <a href="/en-US/docs/Web/API/WebGL_API/Tutorial" title="WebGL tutorial">WebGL tutorial</a> has more information, examples, and resources on how to get started with WebGL.</p>

<h2 id="Constants">Constants</h2>

<p>See the <a href="/en-US/docs/Web/API/WebGL_API/Constants">WebGL constants</a> page.</p>

<h2 id="State_information">State information</h2>

<dl>
 <dt>{{domxref("WebGL2RenderingContext.getIndexedParameter()")}}</dt>
 <dd>Returns the indexed value for the given <code>target</code>.</dd>
</dl>

<h2 id="Buffers">Buffers</h2>

<dl>
 <dt>{{domxref("WebGL2RenderingContext.bufferData()")}}</dt>
 <dd>Initializes and creates the buffer object's data store.</dd>
 <dt>{{domxref("WebGL2RenderingContext.bufferSubData()")}}</dt>
 <dd>Updates a subset of a buffer object's data store.</dd>
 <dt>{{domxref("WebGL2RenderingContext.copyBufferSubData()")}}</dt>
 <dd>Copies part of the data of a buffer to another buffer.</dd>
 <dt>{{domxref("WebGL2RenderingContext.getBufferSubData()")}}</dt>
 <dd>Reads data from a buffer and writes them to an {{jsxref("ArrayBuffer")}} or {{jsxref("SharedArrayBuffer")}}.</dd>
</dl>

<h2 id="Framebuffers">Framebuffers</h2>

<dl>
 <dt>{{domxref("WebGL2RenderingContext.blitFramebuffer()")}}</dt>
 <dd>Transfers a block of pixels from the read framebuffer to the draw framebuffer.</dd>
 <dt>{{domxref("WebGL2RenderingContext.framebufferTextureLayer()")}}</dt>
 <dd>Attaches a single layer of a texture to a framebuffer.</dd>
 <dt>{{domxref("WebGL2RenderingContext.invalidateFramebuffer()")}}</dt>
 <dd>Invalidates the contents of attachments in a framebuffer.</dd>
 <dt>{{domxref("WebGL2RenderingContext.invalidateSubFramebuffer()")}}</dt>
 <dd>Invalidates portions of the contents of attachments in a framebuffer</dd>
 <dt>{{domxref("WebGL2RenderingContext.readBuffer()")}}</dt>
 <dd>Selects a color buffer as the source for pixels.</dd>
</dl>

<h2 id="Renderbuffers">Renderbuffers</h2>

<dl>
 <dt>{{domxref("WebGL2RenderingContext.getInternalformatParameter()")}}</dt>
 <dd>Returns information about implementation-dependent support for internal formats.</dd>
 <dt>{{domxref("WebGL2RenderingContext.renderbufferStorageMultisample()")}}</dt>
 <dd>Creates and initializes a renderbuffer object's data store and allows specifying the number of samples to be used.</dd>
</dl>

<h2 id="Textures">Textures</h2>

<dl>
 <dt>{{domxref("WebGL2RenderingContext.texStorage2D()")}}</dt>
 <dd>Specifies all levels of two-dimensional texture storage.</dd>
 <dt>{{domxref("WebGL2RenderingContext.texStorage3D()")}}</dt>
 <dd>Specifies all levels of a three-dimensional texture or two-dimensional array texture.</dd>
 <dt>{{domxref("WebGL2RenderingContext.texImage3D()")}}</dt>
 <dd>Specifies a three-dimensional texture image.</dd>
 <dt>{{domxref("WebGL2RenderingContext.texSubImage3D()")}}</dt>
 <dd>Specifies a sub-rectangle of the current 3D texture.</dd>
 <dt>{{domxref("WebGL2RenderingContext.copyTexSubImage3D()")}}</dt>
 <dd>Copies pixels from the current <a href="/en-US/docs/Web/API/WebGLFramebuffer" title="The WebGLFramebuffer interface is part of the WebGL API and represents a collection of buffers that serve as a rendering destination."><code>WebGLFramebuffer</code></a> into an existing 3D texture sub-image.</dd>
 <dt>{{domxref("WebGL2RenderingContext.compressedTexImage3D()")}}</dt>
 <dd>Specifies a three-dimensional texture image in a compressed format.</dd>
 <dt>{{domxref("WebGL2RenderingContext.compressedTexSubImage3D()")}}</dt>
 <dd>Specifies a three-dimensional sub-rectangle for a texture image in a compressed format.</dd>
</dl>

<h2 id="Programs_and_shaders">Programs and shaders</h2>

<dl>
 <dt>{{domxref("WebGL2RenderingContext.getFragDataLocation()")}}</dt>
 <dd>Returns the binding of color numbers to user-defined varying out variables.</dd>
</dl>

<h2 id="Uniforms_and_attributes">Uniforms and attributes</h2>

<dl>
 <dt>{{domxref("WebGL2RenderingContext.uniform()", "WebGL2RenderingContext.uniform[1234][uif][v]()")}}</dt>
 <dd>Methods specifying values of uniform variables.</dd>
 <dt>{{domxref("WebGL2RenderingContext.uniformMatrix()", "WebGL2RenderingContext.uniformMatrix[234]x[234]fv()")}}</dt>
 <dd>Methods specifying matrix values for uniform variables.</dd>
 <dt>{{domxref("WebGL2RenderingContext.vertexAttribI()", "WebGL2RenderingContext.vertexAttribI4[u]i[v]()")}}</dt>
 <dd>Methods specifying integer values for generic vertex attributes.</dd>
 <dt>{{domxref("WebGL2RenderingContext.vertexAttribIPointer()")}}</dt>
 <dd>Specifies integer data formats and locations of vertex attributes in a vertex attributes array.</dd>
</dl>

<h2 id="Drawing_buffers">Drawing buffers</h2>

<dl>
 <dt>{{domxref("WebGL2RenderingContext.vertexAttribDivisor()")}}</dt>
 <dd>Modifies the rate at which generic vertex attributes advance when rendering multiple instances of primitives with {{domxref("WebGL2RenderingContext.drawArraysInstanced()", "gl.drawArraysInstanced()")}} and {{domxref("WebGL2RenderingContext.drawElementsInstanced()", "gl.drawElementsInstanced()")}}.</dd>
 <dt>{{domxref("WebGL2RenderingContext.drawArraysInstanced()")}}</dt>
 <dd>Renders primitives from array data. In addition, it can execute multiple instances of the range of elements.</dd>
 <dt>{{domxref("WebGL2RenderingContext.drawElementsInstanced()")}}</dt>
 <dd>Renders primitives from array data. In addition, it can execute multiple instances of a set of elements.</dd>
 <dt>{{domxref("WebGL2RenderingContext.drawRangeElements()")}}</dt>
 <dd>Renders primitives from array data in a given range.</dd>
 <dt>{{domxref("WebGL2RenderingContext.drawBuffers()")}}</dt>
 <dd>Specifies a list of color buffers to be drawn into.</dd>
 <dt>{{domxref("WebGL2RenderingContext.clearBuffer()", "WebGL2RenderingContext.clearBuffer[fiuv]()")}}</dt>
 <dd>Clears buffers from the currently bound framebuffer.</dd>
</dl>

<h2 id="Query_objects">Query objects</h2>

<p>Methods for working with {{domxref("WebGLQuery")}} objects.</p>

<dl>
 <dt>{{domxref("WebGL2RenderingContext.createQuery()")}}</dt>
 <dd>Creates a new {{domxref("WebGLQuery")}} object.</dd>
 <dt>{{domxref("WebGL2RenderingContext.deleteQuery()")}}</dt>
 <dd>Deletes a given {{domxref("WebGLQuery")}} object.</dd>
 <dt>{{domxref("WebGL2RenderingContext.isQuery()")}}</dt>
 <dd>Returns <code>true</code> if a given object is a valid {{domxref("WebGLQuery")}} object.</dd>
 <dt>{{domxref("WebGL2RenderingContext.beginQuery()")}}</dt>
 <dd>Begins an asynchronous query.</dd>
 <dt>{{domxref("WebGL2RenderingContext.endQuery()")}}</dt>
 <dd>Marks the end of an asynchronous query.</dd>
 <dt>{{domxref("WebGL2RenderingContext.getQuery()")}}</dt>
 <dd>Returns a {{domxref("WebGLQuery")}} object for a given target.</dd>
 <dt>{{domxref("WebGL2RenderingContext.getQueryParameter()")}}</dt>
 <dd>Returns information about a query.</dd>
</dl>

<h2 id="Sampler_objects">Sampler objects</h2>

<dl>
 <dt>{{domxref("WebGL2RenderingContext.createSampler()")}}</dt>
 <dd>Creates a new {{domxref("WebGLSampler")}} object.</dd>
 <dt>{{domxref("WebGL2RenderingContext.deleteSampler()")}}</dt>
 <dd>Deletes a given {{domxref("WebGLSampler")}} object.</dd>
 <dt>{{domxref("WebGL2RenderingContext.bindSampler()")}}</dt>
 <dd>Binds a given {{domxref("WebGLSampler")}} to a texture unit.</dd>
 <dt>{{domxref("WebGL2RenderingContext.isSampler()")}}</dt>
 <dd>Returns <code>true</code> if a given object is a valid {{domxref("WebGLSampler")}} object.</dd>
 <dt>{{domxref("WebGL2RenderingContext.samplerParameter()", "WebGL2RenderingContext.samplerParameter[if]()")}}</dt>
 <dd>Sets sampler parameters.</dd>
 <dt>{{domxref("WebGL2RenderingContext.getSamplerParameter()")}}</dt>
 <dd>Returns sampler parameter information.</dd>
</dl>

<h2 id="Sync_objects">Sync objects</h2>

<dl>
 <dt>{{domxref("WebGL2RenderingContext.fenceSync()")}}</dt>
 <dd>Creates a new {{domxref("WebGLSync")}} object and inserts it into the GL command stream.</dd>
 <dt>{{domxref("WebGL2RenderingContext.isSync()")}}</dt>
 <dd>Returns <code>true</code> if the passed object is a valid {{domxref("WebGLSync")}} object.</dd>
 <dt>{{domxref("WebGL2RenderingContext.deleteSync()")}}</dt>
 <dd>Deletes a given {{domxref("WebGLSync")}} object.</dd>
 <dt>{{domxref("WebGL2RenderingContext.clientWaitSync()")}}</dt>
 <dd>
 <p>Blocks and waits for a {{domxref("WebGLSync")}} object to become signaled or a given timeout to be passed.</p>
 </dd>
 <dt>{{domxref("WebGL2RenderingContext.waitSync()")}}</dt>
 <dd>Returns immediately, but waits on the GL server until the given {{domxref("WebGLSync")}} object is signaled.</dd>
 <dt>{{domxref("WebGL2RenderingContext.getSyncParameter()")}}</dt>
 <dd>Returns parameter information of a {{domxref("WebGLSync")}} object.</dd>
</dl>

<h2 id="Transform_feedback">Transform feedback</h2>

<dl>
 <dt>{{domxref("WebGL2RenderingContext.createTransformFeedback()")}}</dt>
 <dd>Creates and initializes {{domxref("WebGLTransformFeedback")}} objects.</dd>
 <dt>{{domxref("WebGL2RenderingContext.deleteTransformFeedback()")}}</dt>
 <dd>Deletes a given {{domxref("WebGLTransformFeedback")}} object.</dd>
 <dt>{{domxref("WebGL2RenderingContext.isTransformFeedback()")}}</dt>
 <dd>Returns <code>true</code> if the passed object is a valid {{domxref("WebGLTransformFeedback")}} object.</dd>
 <dt>{{domxref("WebGL2RenderingContext.bindTransformFeedback()")}}</dt>
 <dd>Binds a passed {{domxref("WebGLTransformFeedback")}} object to the current GL state.</dd>
 <dt>{{domxref("WebGL2RenderingContext.beginTransformFeedback()")}}</dt>
 <dd>Starts a transform feedback operation.</dd>
 <dt>{{domxref("WebGL2RenderingContext.endTransformFeedback()")}}</dt>
 <dd>Ends a transform feedback operation.</dd>
 <dt>{{domxref("WebGL2RenderingContext.transformFeedbackVaryings()")}}</dt>
 <dd>Specifies values to record in {{domxref("WebGLTransformFeedback")}} buffers.</dd>
 <dt>{{domxref("WebGL2RenderingContext.getTransformFeedbackVarying()")}}</dt>
 <dd>Returns information about varying variables from {{domxref("WebGLTransformFeedback")}} buffers.</dd>
 <dt>{{domxref("WebGL2RenderingContext.pauseTransformFeedback()")}}</dt>
 <dd>Pauses a transform feedback operation.</dd>
 <dt>{{domxref("WebGL2RenderingContext.resumeTransformFeedback()")}}</dt>
 <dd>Resumes a transform feedback operation.</dd>
</dl>

<h2 id="Uniform_buffer_objects">Uniform buffer objects</h2>

<dl>
 <dt>{{domxref("WebGL2RenderingContext.bindBufferBase()")}}</dt>
 <dd>Binds a given {{domxref("WebGLBuffer")}} to a given binding point (<code>target</code>) at a given <code>index</code>.</dd>
 <dt>{{domxref("WebGL2RenderingContext.bindBufferRange()")}}</dt>
 <dd>Binds a range of a given {{domxref("WebGLBuffer")}} to a given binding point (<code>target</code>) at a given <code>index</code>.</dd>
 <dt>{{domxref("WebGL2RenderingContext.getUniformIndices()")}}</dt>
 <dd>
 <p>Retrieves the indices of a number of uniforms within a {{domxref("WebGLProgram")}}.</p>
 </dd>
 <dt>{{domxref("WebGL2RenderingContext.getActiveUniforms()")}}</dt>
 <dd>Retrieves information about active uniforms within a {{domxref("WebGLProgram")}}.</dd>
 <dt>{{domxref("WebGL2RenderingContext.getUniformBlockIndex()")}}</dt>
 <dd>Retrieves the index of a uniform block within a {{domxref("WebGLProgram")}}.</dd>
 <dt>{{domxref("WebGL2RenderingContext.getActiveUniformBlockParameter()")}}</dt>
 <dd>Retrieves information about an active uniform block within a {{domxref("WebGLProgram")}}.</dd>
 <dt>{{domxref("WebGL2RenderingContext.getActiveUniformBlockName()")}}</dt>
 <dd>Retrieves the name of the active uniform block at a given index within a {{domxref("WebGLProgram")}}.</dd>
 <dt>{{domxref("WebGL2RenderingContext.uniformBlockBinding()")}}</dt>
 <dd>Assigns binding points for active uniform blocks.</dd>
</dl>

<h2 id="Vertex_array_objects">Vertex array objects</h2>

<p>Methods for working with {{domxref("WebGLVertexArrayObject")}} (VAO) objects.</p>

<dl>
 <dt>{{domxref("WebGL2RenderingContext.createVertexArray()")}}</dt>
 <dd>Creates a new {{domxref("WebGLVertexArrayObject")}}.</dd>
 <dt>{{domxref("WebGL2RenderingContext.deleteVertexArray()")}}</dt>
 <dd>Deletes a given {{domxref("WebGLVertexArrayObject")}}.</dd>
 <dt>{{domxref("WebGL2RenderingContext.isVertexArray()")}}</dt>
 <dd>Returns <code>true</code> if a given object is a valid {{domxref("WebGLVertexArrayObject")}}.</dd>
 <dt>{{domxref("WebGL2RenderingContext.bindVertexArray()")}}</dt>
 <dd>Binds a given {{domxref("WebGLVertexArrayObject")}} to the buffer.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebGL2', "#3.7", "WebGL2RenderingContext")}}</td>
   <td>{{Spec2('WebGL2')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("api.WebGL2RenderingContext")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("HTMLCanvasElement")}}</li>
 <li>{{domxref("WebGLRenderingContext")}}</li>
</ul>
